
/*  A Bison parser, made from gst.y
 by  Bison version A2.6 (Andrew Consortium)
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	BANG	258
#define	COLON	259
#define	UPARROW	260
#define	DOT	261
#define	ASSIGN	262
#define	SHARP	263
#define	SEMICOLON	264
#define	OPEN_PAREN	265
#define	CLOSE_PAREN	266
#define	OPEN_BRACKET	267
#define	CLOSE_BRACKET	268
#define	PRIMITIVE_START	269
#define	INTERNAL_TOKEN	270
#define	IDENTIFIER	271
#define	KEYWORD	272
#define	STRING_LITERAL	273
#define	SYMBOL_KEYWORD	274
#define	BINOP	275
#define	VERTICAL_BAR	276
#define	INTEGER_LITERAL	277
#define	FLOATING_LITERAL	278
#define	CHAR_LITERAL	279

#line 34 "gst.y"

#include "gst.h"
#include "sym.h"
#include "tree.h"
#include "dict.h"
#include "comp.h"
#include "lex.h"
#include <stdio.h>
#if defined(STDC_HEADERS)
#include <string.h>
#endif

#define YYDEBUG 1

extern mst_Boolean		quietExecution;


#line 54 "gst.y"
typedef union{
  char		cval;
  double	fval;
  long		ival;
  char		*sval;
  TreeNode	node;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		158
#define	YYFLAG		-32768
#define	YYNTBASE	25

#define YYTRANSLATE(x) ((unsigned)(x) <= 279 ? yytranslate[x] : 74)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,     8,    10,    13,    17,    20,    23,
    27,    30,    34,    36,    39,    43,    46,    50,    54,    59,
    61,    64,    66,    68,    70,    72,    74,    76,    79,    83,
    85,    89,    92,    96,    98,   101,   102,   104,   108,   110,
   114,   118,   119,   121,   125,   127,   131,   135,   136,   138,
   140,   143,   146,   150,   152,   154,   156,   158,   160,   162,
   166,   168,   170,   172,   174,   176,   178,   180,   183,   185,
   187,   189,   191,   193,   195,   198,   201,   205,   207,   210,
   212,   214,   216,   218,   220,   225,   226,   229,   232,   236,
   238,   240,   242,   245,   247,   249,   253,   255,   257,   260,
   263,   267,   270,   273,   277,   279,   282
};

static const short yyrhs[] = {    27,
     0,    26,    32,     0,     0,    15,     0,    28,     0,    27,
    28,     0,    29,    31,     3,     0,    29,     3,     0,    45,
     3,     0,    40,    45,     3,     0,     1,     3,     0,     3,
    30,     3,     0,    49,     0,    32,     3,     0,    31,    32,
     3,     0,    33,    42,     0,    33,    40,    42,     0,    33,
    39,    42,     0,    33,    40,    39,    42,     0,    34,     0,
    35,    36,     0,    37,     0,     1,     0,    16,     0,    20,
     0,    21,     0,    16,     0,    38,    36,     0,    37,    38,
    36,     0,    17,     0,    14,    22,    20,     0,    21,    21,
     0,    21,    41,    21,     0,    36,     0,    41,    36,     0,
     0,    43,     0,     5,    47,    46,     0,    47,     0,    47,
     6,    42,     0,     1,     6,    42,     0,     0,    45,     0,
     5,    47,    46,     0,    47,     0,    47,     6,    44,     0,
     1,     6,    44,     0,     0,     6,     0,    49,     0,    48,
    49,     0,    36,     7,     0,    48,    36,     7,     0,    50,
     0,    64,     0,    71,     0,    36,     0,    51,     0,    61,
     0,    10,    47,    11,     0,    52,     0,    53,     0,    55,
     0,    56,     0,    57,     0,    22,     0,    23,     0,     8,
    54,     0,    16,     0,    35,     0,    19,     0,    17,     0,
    24,     0,    18,     0,     8,    58,     0,    10,    11,     0,
    10,    59,    11,     0,    60,     0,    59,    60,     0,    52,
     0,    54,     0,    56,     0,    55,     0,    58,     0,    12,
    62,    42,    13,     0,     0,    63,    21,     0,     4,    36,
     0,    63,     4,    36,     0,    65,     0,    67,     0,    69,
     0,    66,    34,     0,    50,     0,    65,     0,    68,    35,
    66,     0,    66,     0,    67,     0,    68,    70,     0,    38,
    68,     0,    70,    38,    68,     0,    64,    72,     0,     9,
    73,     0,    72,     9,    73,     0,    34,     0,    35,    66,
     0,    70,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    90,    92,    93,    96,   100,   102,   105,   107,   108,   114,
   121,   125,   129,   170,   182,   195,   198,   200,   202,   207,
   209,   210,   211,   218,   222,   224,   227,   231,   233,   238,
   242,   251,   253,   257,   259,   263,   265,   268,   272,   273,
   276,   291,   293,   296,   300,   306,   313,   320,   322,   325,
   327,   330,   332,   337,   339,   340,   343,   345,   346,   347,
   350,   352,   353,   354,   355,   358,   360,   363,   367,   369,
   370,   371,   375,   379,   383,   387,   389,   393,   395,   400,
   402,   403,   404,   405,   408,   413,   415,   421,   423,   428,
   430,   431,   434,   438,   440,   443,   448,   450,   453,   458,
   461,   466,   471,   473,   478,   480,   482
};
#endif


#if YYDEBUG != 0

static const char * const yytname[] = {   "$","error","$undefined.","BANG","COLON",
"UPARROW","DOT","ASSIGN","SHARP","SEMICOLON","OPEN_PAREN","CLOSE_PAREN","OPEN_BRACKET",
"CLOSE_BRACKET","PRIMITIVE_START","INTERNAL_TOKEN","IDENTIFIER","KEYWORD","STRING_LITERAL",
"SYMBOL_KEYWORD","BINOP","VERTICAL_BAR","INTEGER_LITERAL","FLOATING_LITERAL",
"CHAR_LITERAL","program","internal_marker","class_definition_list","class_definition",
"class_header","class_specification","method_list","method","message_pattern",
"unary_selector","binary_selector","variable_name","keyword_variable_list","keyword",
"primitive","temporaries","variable_names","statements","non_empty_statements",
"statements_parseLastAsReturn","non_empty_statements_parseLastAsReturn","optional_dot",
"expression","assigns","simple_expression","primary","literal","number","symbol_constant",
"symbol","character_constant","string","array_constant","array","array_constant_list",
"array_constant_elt","block","opt_block_variables","block_variable_list","message_expression",
"unary_expression","unary_object_description","binary_expression","binary_object_description",
"keyword_expression","keyword_binary_object_description_list","cascaded_message_expression",
"semi_message_list","message_elt", NULL
};
#endif

static const short yyr1[] = {     0,
    25,    25,    25,    26,    27,    27,    28,    28,    28,    28,
    28,    29,    30,    31,    31,    32,    32,    32,    32,    33,
    33,    33,    33,    34,    35,    35,    36,    37,    37,    38,
    39,    40,    40,    41,    41,    42,    42,    43,    43,    43,
    43,    44,    44,    45,    45,    45,    45,    46,    46,    47,
    47,    48,    48,    49,    49,    49,    50,    50,    50,    50,
    51,    51,    51,    51,    51,    52,    52,    53,    54,    54,
    54,    54,    55,    56,    57,    58,    58,    59,    59,    60,
    60,    60,    60,    60,    61,    62,    62,    63,    63,    64,
    64,    64,    65,    66,    66,    67,    68,    68,    69,    70,
    70,    71,    72,    72,    73,    73,    73
};

static const short yyr2[] = {     0,
     1,     2,     0,     1,     1,     2,     3,     2,     2,     3,
     2,     3,     1,     2,     3,     2,     3,     3,     4,     1,
     2,     1,     1,     1,     1,     1,     1,     2,     3,     1,
     3,     2,     3,     1,     2,     0,     1,     3,     1,     3,
     3,     0,     1,     3,     1,     3,     3,     0,     1,     1,
     2,     2,     3,     1,     1,     1,     1,     1,     1,     3,
     1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
     1,     1,     1,     1,     2,     2,     3,     1,     2,     1,
     1,     1,     1,     1,     4,     0,     2,     2,     3,     1,
     1,     1,     2,     1,     1,     3,     1,     1,     2,     2,
     3,     2,     2,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     0,     0,     0,     0,    86,     4,    27,    74,     0,
    66,    67,    73,     0,     0,     5,     0,    57,     0,     0,
    45,     0,    50,    54,    58,    61,    62,    63,    64,    65,
    59,    55,    90,    97,    91,     0,    92,    56,    11,     0,
     0,    57,    13,    48,     0,    69,    72,    71,    25,    26,
    70,    68,    75,     0,     0,     0,     0,    32,    34,     0,
    23,    24,    30,     2,     0,    20,     0,    22,     0,     6,
     8,     0,     0,    52,     0,     0,     9,     0,    57,    51,
     0,   102,    93,     0,     0,    99,    47,    43,    12,    49,
    44,    76,    80,    81,    83,    82,    84,     0,    78,    60,
    88,     0,     0,     0,    37,    39,     0,    87,    33,    35,
     0,     0,     0,    16,    21,     0,    28,     7,     0,    14,
    10,    46,    53,   105,     0,   107,   103,     0,    94,    95,
    96,    98,   100,     0,    77,    79,     0,    48,    85,     0,
    89,     0,    18,     0,    17,    29,    15,   106,   104,   101,
    41,    38,    40,    31,    19,     0,     0,     0
};

static const short yydefgoto[] = {   156,
    14,    15,    16,    17,    41,    72,    64,    65,    66,    51,
    18,    68,    69,   112,    19,    60,   104,   105,    87,    20,
    91,   106,    22,    23,    24,    25,    26,    27,    94,    28,
    29,    30,    97,    98,    99,    31,    56,    57,    32,    33,
    34,    35,    36,    37,   126,    38,    82,   127
};

static const short yypact[] = {   122,
    14,   335,   335,   374,   335,    24,-32768,-32768,-32768,    31,
-32768,-32768,-32768,    23,   172,-32768,    88,     9,   311,    50,
    32,   335,-32768,    25,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    55,   380,     2,    60,    81,-32768,-32768,-32768,   271,
    75,-32768,-32768,    79,   344,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    77,    76,   291,    15,-32768,-32768,    35,
-32768,-32768,-32768,-32768,   147,-32768,    76,    83,    76,-32768,
-32768,   321,    90,-32768,    97,   104,-32768,   271,   103,-32768,
   382,   108,-32768,   335,   335,    83,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   359,-32768,-32768,
-32768,   106,   335,   100,-32768,   112,    76,-32768,-32768,-32768,
    98,   247,   197,-32768,-32768,    76,-32768,-32768,   118,-32768,
-32768,-32768,-32768,-32768,   335,    83,-32768,   382,-32768,-32768,
     2,-32768,    51,   335,-32768,-32768,   222,    79,-32768,   222,
-32768,   109,-32768,   247,-32768,-32768,-32768,     2,-32768,    51,
-32768,-32768,-32768,-32768,-32768,   126,   128,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,   116,-32768,-32768,-32768,   -11,-32768,   -32,   -14,
    -1,-32768,   -31,    22,    74,-32768,   -50,-32768,    63,    -9,
     4,     8,-32768,    12,   -55,-32768,   -41,-32768,   145,   -38,
   -33,-32768,   149,-32768,    53,-32768,-32768,-32768,-32768,   -52,
   -49,   -60,   -59,-32768,   120,-32768,-32768,    26
};


#define	YYLAST		403


static const short yytable[] = {    67,
    42,    83,    67,    93,    85,    73,    95,    21,    59,    76,
    44,    96,    54,    43,   114,    74,    39,    62,   107,    40,
    79,    84,    21,    61,   132,   133,    21,    55,   129,   129,
    88,   130,   130,    80,   131,   108,   116,    78,    62,    63,
   -94,   -94,    49,    50,   -94,   -94,     8,    21,   124,    85,
     8,    58,    77,   101,   134,   109,    93,    67,   110,    95,
   119,   143,   145,    81,    96,   115,   125,   117,    88,   129,
    49,    50,   130,   132,   150,   148,   -98,    89,   129,   -98,
   -98,   130,    42,    42,    90,    21,   151,   100,    61,   153,
    71,     8,   120,   155,   134,   124,    85,    63,    83,    63,
    49,    50,    40,    62,    63,   141,   121,    49,    50,   123,
   138,   137,   139,   125,   146,    83,   128,   140,    84,   142,
   147,    -3,     1,    42,     2,   157,     3,   158,   154,     4,
    70,     5,    42,     6,   144,    84,     7,     8,   113,     9,
   122,   152,    10,    11,    12,    13,   -36,   102,    52,   -36,
   136,   103,    53,   149,     4,    86,     5,     0,     6,     0,
   111,     0,     8,     0,     9,     0,     0,    10,    11,    12,
    13,    -1,     1,     0,     2,     0,     3,     0,     0,     4,
     0,     5,     0,     6,     0,     0,     0,     8,     0,     9,
     0,     0,    10,    11,    12,    13,   -36,   102,     0,   -36,
     0,   103,     0,     0,     4,     0,     5,     0,     6,     0,
   111,     0,     8,     0,     9,     0,     0,     0,    11,    12,
    13,   -36,   102,     0,   -36,     0,   103,     0,     0,     4,
     0,     5,     0,     6,   -36,     0,     0,     8,     0,     9,
     0,     0,     0,    11,    12,    13,   -36,   102,     0,   -36,
     0,   103,     0,     0,     4,     0,     5,     0,     6,     0,
     0,     0,     8,     0,     9,     0,     0,     0,    11,    12,
    13,    75,     0,   -42,     0,     3,     0,     0,     4,     0,
     5,     0,     6,     0,     0,     0,     8,     0,     9,     0,
     0,   102,    11,    12,    13,   103,     0,     0,     4,     0,
     5,     0,     6,   -36,     0,     0,     8,     0,     9,     0,
     0,    75,    11,    12,    13,     3,     0,     0,     4,     0,
     5,    61,     6,   118,     0,     0,     8,     0,     9,     0,
     0,     0,    11,    12,    13,     0,    62,    63,     0,     0,
    49,    50,     4,     0,     5,     0,     6,     0,     0,     0,
     8,     0,     9,    45,    92,     0,    11,    12,    13,    46,
    47,     9,    48,    49,    50,    11,    12,    13,    45,   135,
     0,     0,     0,     0,    46,    47,     9,    48,    49,    50,
    11,    12,    13,    45,     0,     0,     0,     0,     0,    46,
    47,     0,    48,    49,    50,   -95,   -95,    62,    63,   -95,
   -95,    49,    50
};

static const short yycheck[] = {    14,
     2,    34,    17,    45,    36,    17,    45,     0,    10,    19,
     3,    45,     5,     2,    65,     7,     3,    16,     4,     6,
    22,    36,    15,     1,    85,    85,    19,     4,    84,    85,
    40,    84,    85,    22,    84,    21,    68,     6,    16,    17,
    16,    17,    20,    21,    20,    21,    16,    40,    81,    81,
    16,    21,     3,    55,    86,    21,    98,    72,    60,    98,
    72,   112,   113,     9,    98,    67,    81,    69,    78,   125,
    20,    21,   125,   134,   134,   125,    17,     3,   134,    20,
    21,   134,    84,    85,     6,    78,   137,    11,     1,   140,
     3,    16,     3,   144,   126,   128,   128,    17,   131,    17,
    20,    21,     6,    16,    17,   107,     3,    20,    21,     7,
   103,     6,    13,   128,   116,   148,     9,     6,   133,    22,
     3,     0,     1,   125,     3,     0,     5,     0,    20,     8,
    15,    10,   134,    12,   113,   150,    15,    16,    65,    18,
    78,   138,    21,    22,    23,    24,     0,     1,     4,     3,
    98,     5,     4,   128,     8,    36,    10,    -1,    12,    -1,
    14,    -1,    16,    -1,    18,    -1,    -1,    21,    22,    23,
    24,     0,     1,    -1,     3,    -1,     5,    -1,    -1,     8,
    -1,    10,    -1,    12,    -1,    -1,    -1,    16,    -1,    18,
    -1,    -1,    21,    22,    23,    24,     0,     1,    -1,     3,
    -1,     5,    -1,    -1,     8,    -1,    10,    -1,    12,    -1,
    14,    -1,    16,    -1,    18,    -1,    -1,    -1,    22,    23,
    24,     0,     1,    -1,     3,    -1,     5,    -1,    -1,     8,
    -1,    10,    -1,    12,    13,    -1,    -1,    16,    -1,    18,
    -1,    -1,    -1,    22,    23,    24,     0,     1,    -1,     3,
    -1,     5,    -1,    -1,     8,    -1,    10,    -1,    12,    -1,
    -1,    -1,    16,    -1,    18,    -1,    -1,    -1,    22,    23,
    24,     1,    -1,     3,    -1,     5,    -1,    -1,     8,    -1,
    10,    -1,    12,    -1,    -1,    -1,    16,    -1,    18,    -1,
    -1,     1,    22,    23,    24,     5,    -1,    -1,     8,    -1,
    10,    -1,    12,    13,    -1,    -1,    16,    -1,    18,    -1,
    -1,     1,    22,    23,    24,     5,    -1,    -1,     8,    -1,
    10,     1,    12,     3,    -1,    -1,    16,    -1,    18,    -1,
    -1,    -1,    22,    23,    24,    -1,    16,    17,    -1,    -1,
    20,    21,     8,    -1,    10,    -1,    12,    -1,    -1,    -1,
    16,    -1,    18,    10,    11,    -1,    22,    23,    24,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    10,    11,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    10,    -1,    -1,    -1,    -1,    -1,    16,
    17,    -1,    19,    20,    21,    16,    17,    16,    17,    20,
    21,    20,    21
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 92 "gst.y"
{ compileMethod(yyvsp[0].node); ;
    break;}
case 4:
#line 97 "gst.y"
{ clearMethodStartPos(); ;
    break;}
case 7:
#line 106 "gst.y"
{ skipCompilation = false; ;
    break;}
case 8:
#line 107 "gst.y"
{ skipCompilation = false; ;
    break;}
case 9:
#line 108 "gst.y"
{ if (!hadError) {
					    executeStatements(nil, yyvsp[-1].node,
							    quietExecution); 
					  }
					  hadError = false;
					;
    break;}
case 10:
#line 115 "gst.y"
{ if (!hadError) {
					    executeStatements(yyvsp[-2].node, yyvsp[-1].node,
							    quietExecution); 
                                          }
					  hadError = false;
                                        ;
    break;}
case 11:
#line 121 "gst.y"
{ hadError = false;
					  yyerrok; ;
    break;}
case 12:
#line 126 "gst.y"
{ clearMethodStartPos(); ;
    break;}
case 13:
#line 130 "gst.y"
{ executeStatements(nil, 
				    makeStatementList(yyvsp[0].node, nil), true); ;
    break;}
case 14:
#line 171 "gst.y"
{ if (!hadError) {
					    if (skipCompilation) {
					      freeTree(yyvsp[-1].node);
					    } else {
					      compileMethod(yyvsp[-1].node);
					      clearMethodStartPos();
					    }
					  } else {
					    hadError = false;
					  }
					;
    break;}
case 15:
#line 182 "gst.y"
{ if (!hadError) {
					    if (skipCompilation) {
					      freeTree(yyvsp[-1].node);
					    } else {
					      compileMethod(yyvsp[-1].node);
					      clearMethodStartPos();
					    }
					  } else {
					    hadError = false;
					  }
					;
    break;}
case 16:
#line 197 "gst.y"
{ yyval.node = makeMethod(yyvsp[-1].node, nil, 0, yyvsp[0].node); ;
    break;}
case 17:
#line 199 "gst.y"
{ yyval.node = makeMethod(yyvsp[-2].node, yyvsp[-1].node, 0, yyvsp[0].node); ;
    break;}
case 18:
#line 201 "gst.y"
{ yyval.node = makeMethod(yyvsp[-2].node, nil, yyvsp[-1].ival, yyvsp[0].node); ;
    break;}
case 19:
#line 203 "gst.y"
{ yyval.node = makeMethod(yyvsp[-3].node, yyvsp[-2].node, yyvsp[-1].ival, yyvsp[0].node); ;
    break;}
case 20:
#line 208 "gst.y"
{ yyval.node = makeUnaryExpr(nil, yyvsp[0].sval); ;
    break;}
case 21:
#line 209 "gst.y"
{ yyval.node = makeBinaryExpr(nil, yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 22:
#line 210 "gst.y"
{ yyval.node = makeKeywordExpr(nil, yyvsp[0].node); ;
    break;}
case 23:
#line 211 "gst.y"
{ errorf("Invalid message pattern");
					  hadError = true;
					  /* 14-Jul-95 00:29:27 removed this yyerrok */
					  /* yyerrok; */
					  yyval.node = nil; ;
    break;}
case 27:
#line 228 "gst.y"
{ yyval.node = makeVariable(yyvsp[0].sval); ;
    break;}
case 28:
#line 232 "gst.y"
{ yyval.node = makeKeywordList(yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 29:
#line 234 "gst.y"
{ addNode(yyvsp[-2].node, makeKeywordList(yyvsp[-1].sval, yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 31:
#line 244 "gst.y"
{ yyval.ival = yyvsp[-1].ival;
					  if (strcmp(yyvsp[0].sval, ">") != 0) {
					    YYERROR;
					  }
					;
    break;}
case 32:
#line 252 "gst.y"
{ yyval.node = nil; ;
    break;}
case 33:
#line 254 "gst.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 34:
#line 258 "gst.y"
{ yyval.node = makeVariableList(yyvsp[0].node); ;
    break;}
case 35:
#line 259 "gst.y"
{ addNode(yyvsp[-1].node, makeVariableList(yyvsp[0].node));
					  yyval.node = yyvsp[-1].node; ;
    break;}
case 36:
#line 264 "gst.y"
{ yyval.node = nil; ;
    break;}
case 38:
#line 270 "gst.y"
{ yyval.node = makeStatementList(makeReturn(yyvsp[-1].node),
				       			nil); ;
    break;}
case 39:
#line 272 "gst.y"
{ yyval.node = makeStatementList(yyvsp[0].node, nil); ;
    break;}
case 40:
#line 275 "gst.y"
{ yyval.node = makeStatementList(yyvsp[-2].node, yyvsp[0].node); ;
    break;}
case 41:
#line 276 "gst.y"
{ yyval.node = yyvsp[0].node;
				  yyerrok;
				  errorf("Error in expression");
				  hadError = true;
				;
    break;}
case 42:
#line 292 "gst.y"
{ yyval.node = nil; ;
    break;}
case 44:
#line 298 "gst.y"
{ yyval.node = makeStatementList(makeReturn(yyvsp[-1].node),
				       			nil); ;
    break;}
case 45:
#line 301 "gst.y"
{ if ( executeExprsFromBrowser )
			yyval.node = makeStatementList(makeReturn(yyvsp[0].node), nil);
		   else			
			yyval.node = makeStatementList(yyvsp[0].node, nil); 
		;
    break;}
case 46:
#line 308 "gst.y"
{ if ( executeExprsFromBrowser && (yyvsp[0].node == nil ) )
			yyval.node = makeStatementList(makeReturn(yyvsp[-2].node), nil);
		   else			
			yyval.node = makeStatementList(yyvsp[-2].node, yyvsp[0].node); 
		;
    break;}
case 47:
#line 313 "gst.y"
{ yyval.node = yyvsp[0].node;
				  yyerrok;
				  errorf("Error in expression");
				  hadError = true;
				;
    break;}
case 51:
#line 327 "gst.y"
{ yyval.node = makeAssign(yyvsp[-1].node, yyvsp[0].node); ;
    break;}
case 52:
#line 331 "gst.y"
{ yyval.node = makeVariableList(yyvsp[-1].node); ;
    break;}
case 53:
#line 333 "gst.y"
{ addNode(yyvsp[-2].node, makeVariableList(yyvsp[-1].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 60:
#line 347 "gst.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 66:
#line 359 "gst.y"
{ yyval.node = makeIntConstant(yyvsp[0].ival); ;
    break;}
case 67:
#line 360 "gst.y"
{ yyval.node = makeFloatConstant(yyvsp[0].fval); ;
    break;}
case 68:
#line 364 "gst.y"
{ yyval.node = makeSymbolConstant(yyvsp[0].node); ;
    break;}
case 69:
#line 368 "gst.y"
{ yyval.node = internIdent(yyvsp[0].sval); ;
    break;}
case 70:
#line 369 "gst.y"
{ yyval.node = internBinOP(yyvsp[0].sval); ;
    break;}
case 71:
#line 370 "gst.y"
{ yyval.node = internIdent(yyvsp[0].sval); ;
    break;}
case 72:
#line 371 "gst.y"
{ yyval.node = internIdent(yyvsp[0].sval); ;
    break;}
case 73:
#line 376 "gst.y"
{ yyval.node = makeCharConstant(yyvsp[0].cval); ;
    break;}
case 74:
#line 380 "gst.y"
{ yyval.node = makeStringConstant(yyvsp[0].sval); ;
    break;}
case 75:
#line 384 "gst.y"
{ yyval.node = makeArrayConstant(yyvsp[0].node); ;
    break;}
case 76:
#line 388 "gst.y"
{ yyval.node = nil; ;
    break;}
case 77:
#line 390 "gst.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 78:
#line 394 "gst.y"
{ yyval.node = makeArrayElt(yyvsp[0].node); ;
    break;}
case 79:
#line 396 "gst.y"
{ addNode(yyvsp[-1].node, makeArrayElt(yyvsp[0].node));
					  yyval.node = yyvsp[-1].node; ;
    break;}
case 85:
#line 410 "gst.y"
{ yyval.node = makeBlock(yyvsp[-2].node, yyvsp[-1].node); ;
    break;}
case 86:
#line 414 "gst.y"
{ yyval.node = nil; ;
    break;}
case 88:
#line 422 "gst.y"
{ yyval.node = makeVariableList(yyvsp[0].node); ;
    break;}
case 89:
#line 424 "gst.y"
{ addNode(yyvsp[-2].node, makeVariableList(yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 93:
#line 435 "gst.y"
{ yyval.node = makeUnaryExpr(yyvsp[-1].node, yyvsp[0].sval); ;
    break;}
case 96:
#line 445 "gst.y"
{ yyval.node = makeBinaryExpr(yyvsp[-2].node, yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 99:
#line 455 "gst.y"
{ yyval.node = makeKeywordExpr(yyvsp[-1].node, yyvsp[0].node); ;
    break;}
case 100:
#line 460 "gst.y"
{ yyval.node = makeKeywordList(yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 101:
#line 462 "gst.y"
{ addNode(yyvsp[-2].node, makeKeywordList(yyvsp[-1].sval, yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 102:
#line 468 "gst.y"
{ yyval.node = makeCascadedMessage(yyvsp[-1].node, yyvsp[0].node); ;
    break;}
case 103:
#line 472 "gst.y"
{ yyval.node = makeMessageList(yyvsp[0].node); ;
    break;}
case 104:
#line 474 "gst.y"
{ addNode(yyvsp[-2].node, makeMessageList(yyvsp[0].node));
					  yyval.node = yyvsp[-2].node; ;
    break;}
case 105:
#line 479 "gst.y"
{ yyval.node = makeUnaryExpr(nil, yyvsp[0].sval); ;
    break;}
case 106:
#line 481 "gst.y"
{ yyval.node = makeBinaryExpr(nil, yyvsp[-1].sval, yyvsp[0].node); ;
    break;}
case 107:
#line 483 "gst.y"
{ yyval.node = makeKeywordExpr(nil, yyvsp[0].node); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 487 "gst.y"

/*     
ADDITIONAL C CODE
*/

